InsightHub/InsightHub/InsightHub/Models/HomeViewModel.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;

namespace InsightHub.Web.Models
{
    public class HomeViewModel
    {
        public List<ReportViewModel> Newest { get; set; }

        public List<ReportViewModel> MostDownloaded { get; set; }

        public List<ReportViewModel> Featured { get; set; }
    }
}

InsightHub/InsightHub/InsightHub/Controllers/HomeController.cs
using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.Extensions.Logging;
using InsightHub.Models;
using InsightHub.Services.Contracts;
using InsightHub.Web.Models;

namespace InsightHub.Controllers
{
    /// <summary>
    /// Provides functionality to the /Home/ route:
    ///  -  Displays a home page
    ///   -  Displays a reports index page.
    /// </summary>
    public class HomeController : Controller
    {
        private readonly ILogger<HomeController> _logger;
        private readonly IReportService reportService;

        public HomeController(ILogger<HomeController> logger, IReportService reportService)
        {
            _logger = logger;
            this.reportService = reportService;
        }

        public async Task<IActionResult> Index()
        {
            var mostDownloaded = await this.reportService.GetFiveMostDownloadedReportsAsync();
            var featured = await this.reportService.GetFeaturedReportsAsync();
            var newest = await this.reportService.GetFiveNewestReportsAsync();

            var homeViewModel = new HomeViewModel
            {
                Featured = featured.Select(r => new ReportViewModel(r)).ToList(),
                MostDownloaded = mostDownloaded.Select(r => new ReportViewModel(r)).ToList(),
                Newest = newest.Select(r => new ReportViewModel(r)).ToList()
            };

            return View(homeViewModel);
        }

        public IActionResult PageNotFound()
        {
            return View();
        }

        [ResponseCache(Duration = 0, Location = ResponseCacheLocation.None, NoStore = true)]
        public IActionResult Error()
        {
            return View(new ErrorViewModel { RequestId = Activity.Current?.Id ?? HttpContext.TraceIdentifier });
        }
    }
}

InsightHub/InsightHub/InsightHub/Controllers/ReportsController.cs
using InsightHub.Data;
using InsightHub.Services.Contracts;
using InsightHub.Services.Providers.Contracts;
using InsightHub.Web.Models;
using InsightHub.Web.Models.ReportMVCModels;
using Microsoft.AspNetCore.Mvc;
using System;
using System.Linq;
using System.Threading.Tasks;

namespace InsightHub.Web.Controllers
{
    /// <summary>
    /// Provides functionality to the /Report/ route:
    ///   -  Displays a reports' index page
    ///    - Displays a reports' details page
    ///     - Displays a reports' download action
    /// </summary>
    public class ReportsController : Controller
    {
        private readonly InsightHubContext context;
        private readonly IReportService reportService;
        private readonly ITagService tagService;
        private readonly IIndustryService industryService;
        private readonly IUserService userService;
        private readonly IFileTypeProvider fileTypeProvider;

        public ReportsController(InsightHubContext context, IReportService reportService, 
            ITagService tagService, IIndustryService industryService, IUserService userService, IFileTypeProvider fileTypeProvider)
        {
            this.context = context;
            this.reportService = reportService;
            this.tagService = tagService;
            this.industryService = industryService;
            this.userService = userService;
            this.fileTypeProvider = fileTypeProvider;
        }

        // GET: Reports
        public async Task<IActionResult> Index()
        {
            var reports = await this.reportService.GetAllApprovedReportsAsync();
            
            var reportsViewModel = reports.Select(r => new IndexReportViewModel
            {
                Id = r.Id,
                Name = r.Name,
                Description = r.Description,
                Industry = new IndustryViewModel { Id = r.Industry.Id, Name = r.Industry.Name},
                Author = r.Author,
                Tags = r.Tags.Select(tag => new TagViewModel { Id = tag.Id, Name = tag.Name }).ToList(),
                CreatedOn = r.CreatedOn,
                TimesDownloaded = r.TimesDownloaded
            });

            return View(reportsViewModel);
        }

        // GET: Reports/Details/5
        public async Task<IActionResult> Details(int id)
        {
            try
            {
                var report = await this.reportService.GetReportAsync(id);

                var reportsViewModel = new DetailsMVCViewModel
                {
                    Id = report.Id,
                    Name = report.Name,
                    Description = report.Description,
                    Industry = new IndustryViewModel { Id = report.Industry.Id, Name = report.Industry.Name },
                    Author = report.Author,
                    Tags = report.Tags.Select(tag => new TagViewModel { Id = tag.Id, Name = tag.Name }).ToList(),
                    TimesDownloaded = report.TimesDownloaded,
                    FileName = report.FileName
                };

                if (report == null)
                {
                    return NotFound();
                }

                return View(reportsViewModel);
            }
            catch (Exception)
            {
                return NotFound();
            }

        }


        public async Task<IActionResult> DownloadFile(int id)
        {
            try
            {
                var userID = int.Parse(User.FindFirst(System.Security.Claims.ClaimTypes.NameIdentifier).Value);
                var report = await this.reportService.GetReportAsync(id);
                if (report == null)
                {
                    return BadRequest();
                }
                var memory = await this.reportService.DownloadReportAsync(id, userID);

                var ext = fileTypeProvider.GetFileType(report.FileName);

                return File(memory, ext, report.FileName);
            }
            catch (Exception)
            {
                return NotFound();
            }
        }

        
    }
}

InsightHub/InsightHub/InsightHub/Views/Home/Index.cshtml
@model InsightHub.Web.Models.HomeViewModel

@{
    ViewData["Title"] = "Home Page";
    Layout = "~/Views/Shared/_Layout.cshtml";
}
@section Styles
    {
        <style type="text/css">
            body {
                background-image: url('images/homepage.jpg');
                background-repeat: no-repeat;
                background-position: center;
                background-size: cover;
            }
        </style>
    }
<div class="background">
    <div class="jumbotron text-center bg-transparent">
        <div class="container">
            <h1 class="text-light">D&D's InsightHub</h1>
            <p class="text-light">The largest portal for business reports!</p>
        </div>
    </div>

    <div class="container">
        <div class="row">
            <div class="col-sm-4">
                <h3 class="card-header text-black-50" style="background-color:white">Newest Reports</h3>
                <img style="height: 200px; width: 100%; display: block;" src="~/images/calendar2.jpg" alt="Card image">
                <ul class="list-group list-group-flush">
                    @foreach (var report in Model.Newest)
                    {
                        <li class="list-group-item text-black-50">@Html.ActionLink(report.Name, "Details", "Reports", new { id = report.Id })</li>
                    }
                </ul>
            </div>
            <div class="col-sm-4">
                <h3 class="card-header text-black-50" style="background-color:white">Most Downloaded</h3>
                <img style="height: 200px; width: 100%; display: block;" src="~/images/download.jpg" alt="Card image">
                <ul class="list-group list-group-flush">
                    @foreach (var report in Model.MostDownloaded)
                    {
                        <li class="list-group-item text-black-50">@Html.ActionLink(report.Name, "Details", "Reports", new { id = report.Id })</li>
                    }
                </ul>
            </div>
            <div class="col-sm-4">
                <h3 class="card-header text-black-50" style="background-color:white">Featured Reports</h3>
                <img style="height: 200px; width: 100%; display: block;" src="~/images/star.jpg" alt="Card image">
                <ul class="list-group list-group-flush">
                    @foreach (var report in Model.Featured)
                    {
                        <li class="list-group-item text-black-50">@Html.ActionLink(report.Name, "Details", "Reports", new { id = report.Id })</li>
                    }
                </ul>
            </div>
        </div>
    </div>
</div>

InsightHub/InsightHub/InsightHub/Views/Home/PageNotFound.cshtml
@{
    ViewData["Title"] = "Page Not Found";
}

<div class="page-header header-filter" data-parallax="true" style="background-image: url('images/404-page-not-found.jpg');
">
    <div class="container">
        <div class="row">
            <div class="col-md-6">
                
            </div>
        </div>
    </div>
</div>
<div class="container-fluid px-0">
    <div class="row">
        <div class="col-md-0">
            <img src="~/images/404-page-not-found.jpg" style="width: 100%; height: 90%" />
        </div>
    </div>
</div>